xmonad-contrib-0.15: Third party extensions for xmonad

Copyright | (c) 2007 Andrea Rossato
License | BSD-style (see xmonad/LICENSE)
Maintainer | andrea.rossato@unibz.it
Stability | unstable
Portability | unportable
Safe Haskell | None
Language | Haskell98

XMonad.Layout.DwmStyle

Contents

- Usage:

Description

A layout modifier for decorating windows in a dwm like style.

Synopsis

- dwmStyle :: (Eq a, Shrinker s) => s -> Theme -> l a -> ModifiedLayout (Decoration DwmStyle s) l a
- data Theme = Theme {
  - activeColor :: String
  - inactiveColor :: String
  - urgentColor :: String
  - activeBorderColor :: String
  - inactiveBorderColor :: String
  - urgentBorderColor :: String
  - activeTextColor :: String
  - inactiveTextColor :: String
  - urgentTextColor :: String
  - fontName :: String
  - decoWidth :: Dimension
  - decoHeight :: Dimension
  - windowTitleAddons :: [(String, Align)]
  - windowTitleIcons :: [([[Bool]], Placement)]
  }
- def :: Default a => a
- defaultTheme :: Theme
- data DwmStyle a = Dwm
- shrinkText :: DefaultShrinker
- data CustomShrink = CustomShrink
- class (Read s, Show s) => Shrinker s where
  - shrinkIt :: s -> String -> [String]

# Usage:

You can use this module with the following in your `~/.xmonad/xmonad.hs`:

    import XMonad.Layout.DwmStyle

Then edit your `layoutHook` by adding the DwmStyle decoration to your layout:

    myL = dwmStyle shrinkText def (layoutHook def)
    main = xmonad def { layoutHook = myL }

For more detailed instructions on editing the layoutHook see:

XMonad.Doc.Extending

You can also edit the default configuration options.

    myDWConfig = def { inactiveBorderColor = "red"
                     , inactiveTextColor   = "red"}

and

    myL = dwmStyle shrinkText myDWConfig (layoutHook def)

A complete xmonad.hs file for this would therefore be:

    import XMonad
    import XMonad.Layout.DwmStyle

    main = xmonad def {
        layoutHook = dwmStyle shrinkText def (layoutHook def)
        }

dwmStyle :: (Eq a, Shrinker s) => s -> Theme -> l a -> ModifiedLayout (Decoration DwmStyle s) l a Source #

Add simple old dwm-style decorations to windows of a layout.

data Theme Source #

A `Theme` is a record of colors, font etc., to customize a `DecorationStyle`.

For a collection of `Theme`s see XMonad.Util.Themes

Constructors

Theme |

Fields

- activeColor :: String

  Color of the active window

- inactiveColor :: String

  Color of the inactive window

- urgentColor :: String

  Color of the urgent window

- activeBorderColor :: String

  Color of the border of the active window

- inactiveBorderColor :: String

  Color of the border of the inactive window

- urgentBorderColor :: String

  Color of the border of the urgent window

- activeTextColor :: String

  Color of the text of the active window

- inactiveTextColor :: String

  Color of the text of the inactive window

- urgentTextColor :: String

  Color of the text of the urgent window

- fontName :: String

  Font name

- decoWidth :: Dimension

  Maximum width of the decorations (if supported by the `DecorationStyle`)

- decoHeight :: Dimension

  Height of the decorations

- windowTitleAddons :: [(String, Align)]

  Extra text to appear in a window's title bar. Refer to for a use XMonad.Layout.ImageButtonDecoration

- windowTitleIcons :: [([[Bool]], Placement)]

  Extra icons to appear in a window's title bar. Inner `[Bool]` is a row in a icon bitmap.

Instances

Read Theme Source # |
Instance details Defined in XMonad.Layout.Decoration Methods readsPrec :: Int -> ReadS Theme Source # readList :: ReadS [Theme] Source # readPrec :: ReadPrec Theme Source # readListPrec :: ReadPrec [Theme] Source #
Show Theme Source # |
Instance details Defined in XMonad.Layout.Decoration Methods showsPrec :: Int -> Theme -> ShowS Source # show :: Theme -> String Source # showList :: [Theme] -> ShowS Source #
Default Theme Source # |
Instance details Defined in XMonad.Layout.Decoration Methods def :: Theme #

def :: Default a => a #

defaultTheme :: Theme Source #

Deprecated: Use def (from Data.Default, and re-exported by XMonad.Layout.Decoration) instead.

The default xmonad `Theme`.

data DwmStyle a Source #

Constructors

Dwm |

Instances

Eq a => DecorationStyle DwmStyle a Source # |

Instance details

Defined in XMonad.Layout.DwmStyle

Methods

describeDeco :: DwmStyle a -> String Source #

shrink :: DwmStyle a -> Rectangle -> Rectangle -> Rectangle Source #

decorationEventHook :: DwmStyle a -> DecorationState -> Event -> X () Source #

decorationCatchClicksHook :: DwmStyle a -> Window -> Int -> Int -> X Bool Source #

decorationWhileDraggingHook :: DwmStyle a -> CInt -> CInt -> (Window, Rectangle) -> Position -> Position -> X () Source #

decorationAfterDraggingHook :: DwmStyle a -> (Window, Rectangle) -> Window -> X () Source #

pureDecoration :: DwmStyle a -> Dimension -> Dimension -> Rectangle -> Stack a -> [(a, Rectangle)] -> (a, Rectangle) -> Maybe Rectangle Source #

decorate :: DwmStyle a -> Dimension -> Dimension -> Rectangle -> Stack a -> [(a, Rectangle)] -> (a, Rectangle) -> X (Maybe Rectangle) Source #

Read (DwmStyle a) Source # |
Instance details Defined in XMonad.Layout.DwmStyle Methods readsPrec :: Int -> ReadS (DwmStyle a) Source # readList :: ReadS [DwmStyle a] Source # readPrec :: ReadPrec (DwmStyle a) Source # readListPrec :: ReadPrec [DwmStyle a] Source #
Show (DwmStyle a) Source # |
Instance details Defined in XMonad.Layout.DwmStyle Methods showsPrec :: Int -> DwmStyle a -> ShowS Source # show :: DwmStyle a -> String Source # showList :: [DwmStyle a] -> ShowS Source #

shrinkText :: DefaultShrinker Source #

data CustomShrink Source #

Constructors

CustomShrink |

Instances

Read CustomShrink Source # |
Instance details Defined in XMonad.Layout.Decoration Methods readsPrec :: Int -> ReadS CustomShrink Source # readList :: ReadS [CustomShrink] Source # readPrec :: ReadPrec CustomShrink Source # readListPrec :: ReadPrec [CustomShrink] Source #
Show CustomShrink Source # |
Instance details Defined in XMonad.Layout.Decoration Methods showsPrec :: Int -> CustomShrink -> ShowS Source # show :: CustomShrink -> String Source # showList :: [CustomShrink] -> ShowS Source #
Shrinker CustomShrink Source # |
Instance details Defined in XMonad.Config.Droundy Methods shrinkIt :: CustomShrink -> String -> [String] Source #

class (Read s, Show s) => Shrinker s where Source #

Methods

shrinkIt :: s -> String -> [String] Source #

Instances

Shrinker DefaultShrinker Source # |
Instance details Defined in XMonad.Layout.Decoration Methods shrinkIt :: DefaultShrinker -> String -> [String] Source #
Shrinker CustomShrink Source # |
Instance details Defined in XMonad.Config.Droundy Methods shrinkIt :: CustomShrink -> String -> [String] Source #